## uos-recovery 6.0.15

=== CMakeLists.txt ===
# 工程设置
cmake_minimum_required(VERSION 3.1)
project(uos-recovery C CXX)

set(CMAKE_CXX_STANDARD_REQUIRED 14)
set(CMAKE_C_STANDARD 11)
set(CMAKE_C_STANDARD_REQUIRED ON)

# 启用qt moc机制
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

configure_file(${CMAKE_SOURCE_DIR}/src/utils/environments.h.in ${CMAKE_SOURCE_DIR}/src/utils/environments.h @ONLY)

if (CMAKE_BUILD_TYPE MATCHES Debug)
    # 默认优化编译参数
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -O2 ")
    #set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wno-unused-result -Wno-switch-default -Wno-padded")
    # 安全编译参数
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -z noexecstack -pie -fPIC -z relro -z now -fstack-protector-all")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -z noexecstack -pie -fPIC -z relro -z now -fstack-protector-all")
    add_definitions("-DTEST_DATA_DIR=\"${CMAKE_SOURCE_DIR}/src/test/testData/\"")
    #add_definitions("-DUI_TEST")
    option(TEST on)
else()
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -z noexecstack -pie -fPIC -z relro -z now -fstack-protector-all")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -z noexecstack -pie -fPIC -z relro -z now -fstack-protector-all")
    add_definitions("-DQT_MESSAGELOGCONTEXT")
    option(TEST off)
endif()

# generate qm
#execute_process(COMMAND bash "translate_generation.sh"
#        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})


set(UTILS_DIR ${CMAKE_SOURCE_DIR}/src/utils)
set(TEST_DIR ${CMAKE_SOURCE_DIR}/src/test)
set(SERVER_DIR ${CMAKE_SOURCE_DIR}/src/uos-recovery-service)
set(GUI_DIR ${CMAKE_SOURCE_DIR}/src/uos-recovery-gui)
set(UIMGINSTALLERR_DIR ${CMAKE_SOURCE_DIR}/src/uimg-installer)
set(RECOVERYTOOL_DIR ${CMAKE_SOURCE_DIR}/src/uos-recovery-tool)

execute_process(COMMAND bash "-c" "qdbuscpp2xml -A ${SERVER_DIR}/RecoveryService.h -o com.deepin.daemon.uosrecovery.xml"
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

execute_process(COMMAND bash "-c" "qdbusxml2cpp ${CMAKE_SOURCE_DIR}/com.deepin.daemon.uosrecovery.xml -i RecoveryService.h -a RecoveryAdaptor"
        WORKING_DIRECTORY ${SERVER_DIR})

execute_process(COMMAND bash "-c" "qdbusxml2cpp ${CMAKE_SOURCE_DIR}/com.deepin.daemon.uosrecovery.xml -p RecoveryProxy"
        WORKING_DIRECTORY ${GUI_DIR})

add_subdirectory(src/uos-recovery-gui)
add_subdirectory(src/uos-recovery-service)
add_subdirectory(src/uimg-installer)
add_subdirectory(src/uos-recovery-tool)

if (CMAKE_BUILD_TYPE MATCHES Debug)
    add_subdirectory(src/test)
endif()

=== src/test/CMakeLists.txt ===
set(BIN_NAME uos-recovery-test)


set(CMAKE_INCLUDE_CURRENT_DIR  ON)

find_package(Qt5Core REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(Qt5PrintSupport REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(DtkCMake REQUIRED)
find_package(PkgConfig REQUIRED)
find_package(PolkitQt5-1 REQUIRED)
find_package(Qt5Sql REQUIRED)

pkg_check_modules(DtkWidget REQUIRED dtkwidget)

include_directories(${CMAKE_SOURCE_DIR}/src)
include_directories(${UTILS_DIR})

aux_source_directory(${UTILS_DIR} TEST_SRCS)
aux_source_directory(${UTILS_DIR}/data-collection TEST_SRCS)
aux_source_directory(${TEST_DIR} TEST_SRCS)


add_executable(${BIN_NAME}
        ${TEST_SRCS}
        ${SERVER_DIR}/SystemRecovery.h
        ${SERVER_DIR}/SystemRecovery.cpp
        ${SERVER_DIR}/RecoveryService.h
        ${SERVER_DIR}/RecoveryService.cpp
        ${SERVER_DIR}/RsyncSystem.h
        ${SERVER_DIR}/RsyncSystem.cpp
        ${SERVER_DIR}/OSTreeSystem.h
        ${SERVER_DIR}/OSTreeSystem.cpp
        ${SERVER_DIR}/BtrfsSystem.h
        ${SERVER_DIR}/BtrfsSystem.cpp
        ${SERVER_DIR}/LvmSystem.h
        ${SERVER_DIR}/LvmSystem.cpp

        ${SERVER_DIR}/UserDataRecovery.h
        ${SERVER_DIR}/UserDataRecovery.cpp
        ${SERVER_DIR}/RsyncUserData.h
        ${SERVER_DIR}/RsyncUserData.cpp
        ${SERVER_DIR}/BtrfsUserData.h
        ${SERVER_DIR}/BtrfsUserData.cpp
        ${SERVER_DIR}/LvmUserData.h
        ${SERVER_DIR}/LvmUserData.cpp

        ${SERVER_DIR}/DBInterface.cpp
        ${SERVER_DIR}/DBInterface.h

        ${SERVER_DIR}/DimFileRecovery.h
        ${SERVER_DIR}/DimFileRecovery.cpp
        ${SERVER_DIR}/DimFileHandle.h
        ${SERVER_DIR}/DimFileHandle.cpp

        ${SERVER_DIR}/UImgRecovery.h
        ${SERVER_DIR}/UImgRecovery.cpp
        ${SERVER_DIR}/GhostUImg.h
        ${SERVER_DIR}/GhostUImg.cpp

        ${UIMGINSTALLERR_DIR}/UImgOperate.h
        ${UIMGINSTALLERR_DIR}/UImgOperate.cpp
        )

target_include_directories(${BIN_NAME} PUBLIC
        ${DtkWidget_INCLUDE_DIRS}
        )

target_link_libraries(${BIN_NAME}
        ${Qt5Widgets_LIBRARIES}
        ${Qt5DBus_LIBRARIES}
        ${DtkWidget_LIBRARIES}
        Qt5::PrintSupport
        PolkitQt5-1::Agent
        ${Qt5Sql_LIBRARIES}
        )

target_link_libraries(${BIN_NAME}
        Qt5::Core
        Qt5::DBus
        gtest
        gtest_main
        pthread
        )

=== src/uimg-installer/CMakeLists.txt ===
set(BIN_NAME uimg-installer)

find_package(Qt5Core REQUIRED)
find_package(Qt5PrintSupport REQUIRED)
find_package(PolkitQt5-1 REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(DtkCMake REQUIRED)

include_directories(${UTILS_DIR})
include_directories(${CMAKE_SOURCE_DIR}/src)
aux_source_directory(${UTILS_DIR} SRC_FILES)
aux_source_directory(${UIMGINSTALLERR_DIR} SRC_FILES)

## 源文件
add_executable(${BIN_NAME}
        ${SRC_FILES}
        )

target_link_libraries(${BIN_NAME}
        ${Qt5Core_LIBRARIES}
        ${Qt5DBus_LIBRARIES}
        ${DtkWidget_LIBRARIES}
        Qt5::PrintSupport
        PolkitQt5-1::Agent
        )

## 安装目标文件
install(TARGETS ${BIN_NAME}
        DESTINATION bin/)

=== src/uos-recovery-gui/CMakeLists.txt ===
set(BIN_NAME uos-recovery-gui)

find_package(Qt5Core REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(Qt5PrintSupport REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(DtkCMake REQUIRED)
find_package(PkgConfig REQUIRED)
find_package(PolkitQt5-1 REQUIRED)

pkg_check_modules(DtkWidget REQUIRED dtkwidget)

include_directories(${CMAKE_SOURCE_DIR}/src)
include_directories(.)

aux_source_directory(${GUI_DIR} GUI_SRCS)
aux_source_directory(${GUI_DIR}/backup/ GUI_SRCS)
aux_source_directory(${GUI_DIR}/restore/ GUI_SRCS)
aux_source_directory(${GUI_DIR}/advanced/ GUI_SRCS)
aux_source_directory(${GUI_DIR}/common/ GUI_SRCS)
aux_source_directory(${UTILS_DIR} GUI_SRCS)

add_executable(${BIN_NAME}
        ${GUI_SRCS}
        resources.qrc
        )

target_include_directories(${BIN_NAME} PUBLIC
        ${DtkWidget_INCLUDE_DIRS}
        )


target_link_libraries(${BIN_NAME}
        ${Qt5Widgets_LIBRARIES}
        ${Qt5DBus_LIBRARIES}
        ${DtkWidget_LIBRARIES}
        Qt5::PrintSupport
        PolkitQt5-1::Agent
        )

# 生成翻译
## 设置QT语言cmake模块
find_package(Qt5 COMPONENTS Widgets LinguistTools REQUIRED)

## 通过源代码生成ts文件
set(CREATE_TS_DIR
    ${CMAKE_SOURCE_DIR}/src/uos-recovery-gui
)

find_program(LUPDATE_EXECUTABLE lupdate)
execute_process(
    COMMAND ${LUPDATE_EXECUTABLE} -source-language en
    -no-obsolete
    -recursive ${CREATE_TS_DIR}
    -ts ${CMAKE_SOURCE_DIR}/translations/gui/uos-recovery-gui.ts)

execute_process(
        COMMAND python ${CMAKE_CURRENT_SOURCE_DIR}/translate_gui_unfinised.py ${CMAKE_SOURCE_DIR}/translations/gui/uos-recovery-gui.ts
        ${CMAKE_SOURCE_DIR}/translations/gui/uos-recovery-gui_en_US.ts)
#execute_process(
#        COMMAND cp -rf ${CMAKE_SOURCE_DIR}/translations/gui/uos-recovery-gui.ts
#        ${CMAKE_SOURCE_DIR}/translations/gui/uos-recovery-gui_en_US.ts)

## 获取ts源文件
file(GLOB INSTALLER_TRANSLATION_TS
    ${CMAKE_SOURCE_DIR}/translations/gui/uos-recovery-gui*.ts)

# generate qm
execute_process(COMMAND bash "${CMAKE_SOURCE_DIR}/translate_generation.sh"
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

if (CMAKE_BUILD_TYPE MATCHES Debug)
    add_definitions("-DDI_I18N_GUI_DIR_ENV=\"${CMAKE_SOURCE_DIR}/translations/gui\"")
else()
    add_definitions("-DDI_I18N_GUI_DIR_ENV=\"/usr/share/uos-recovery/translations/gui\"")
endif()

#install

# bin
install(TARGETS ${BIN_NAME}
        DESTINATION /usr/bin/)

#translations
# desktop
file(GLOB DESKTOP_QM_FILES "${CMAKE_SOURCE_DIR}/translations/desktop/*.qm")
install(FILES ${DESKTOP_QM_FILES}
        DESTINATION /usr/share/uos-recovery/translations/desktop/)
# gui
file(GLOB QM_FILES "${CMAKE_SOURCE_DIR}/translations/gui/*.qm")
install(FILES ${QM_FILES}
        DESTINATION /usr/share/uos-recovery/translations/gui/)
#icon
install(FILES resources/icons/uos-recovery.svg
        DESTINATION /usr/share/icons/hicolor/scalable/apps)

#desktop
# desktop
install(FILES uos-recovery.desktop DESTINATION /usr/share/applications)

=== src/uos-recovery-service/CMakeLists.txt ===
set(BIN_NAME uos-recovery-service)


aux_source_directory(${UTILS_DIR} SERVICE_SRCS)
aux_source_directory(${UTILS_DIR}/data-collection SERVICE_SRCS)
aux_source_directory(${SERVER_DIR} SERVICE_SRCS)

find_package(PkgConfig REQUIRED)
find_package(Qt5Core REQUIRED)
find_package(DtkCMake REQUIRED)
find_package(DtkWidget REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(Qt5Sql REQUIRED)
find_package(PolkitQt5-1 REQUIRED)

include_directories(${CMAKE_SOURCE_DIR}/src)

aux_source_directory(${SERVER_DIR} SERVICE_SRCS)

add_executable(uos-recovery-service
        ${SERVICE_SRCS}
        )

target_include_directories(${BIN_NAME} PUBLIC
        ${DtkWidget_INCLUDE_DIRS}
        )


target_link_libraries(${BIN_NAME}
        ${Qt5Widgets_LIBRARIES}
        ${Qt5DBus_LIBRARIES}
        ${Qt5Sql_LIBRARIES}
        ${DtkWidget_LIBRARIES}
        PolkitQt5-1::Agent
        )


#translations

# bin
install(TARGETS ${BIN_NAME}
        DESTINATION /usr/lib/deepin-daemon)

#scripts
#file(GLOB SCRIPTS "scripts/*")
#install(FILES ${SCRIPTS}
#        DESTINATION lib/uos-recovery/scripts/)

install(FILES scripts/recovery-hooks
        DESTINATION /usr/share/initramfs-tools/hooks/
        PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)
install(FILES scripts/initrd-recovery
        DESTINATION /usr/share/initramfs-tools/scripts/local-bottom/
        PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)
install(FILES scripts/recovery-utils
        DESTINATION /usr/share/initramfs-tools/scripts/local-bottom/
        PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)

# grub 还原脚本和配置文件
install(FILES scripts/recovery-by-grub
        DESTINATION /var/lib/uos-recovery/scripts/
        PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)
install(FILES config/recovery.json
        DESTINATION /var/lib/deepin-boot-kit/config)

#app ini
install(FILES config/uos-recovery.ini
        DESTINATION /etc/uos-recovery/)

# dbus conf
install(FILES service/com.deepin.uosrecovery.conf
        DESTINATION /usr/share/dbus-1/system.d/)

#dbus service
install(FILES service/com.deepin.uosrecovery.service
        DESTINATION /usr/share/dbus-1/system-services/)

# dbus policy
install(FILES service/com.deepin.uosrecovery.policy
        DESTINATION /usr/share/polkit-1/actions/)

=== src/uos-recovery-tool/CMakeLists.txt ===
set(BIN_NAME uos-recovery-tool)

find_package(Qt5Core REQUIRED)
find_package(Qt5PrintSupport REQUIRED)
find_package(DtkCMake REQUIRED)

include_directories(${CMAKE_SOURCE_DIR}/src)
aux_source_directory(${RECOVERYTOOL_DIR} SRC_FILES)

## 源文件
add_executable(${BIN_NAME}
        ${SRC_FILES}
        main.cpp)

target_link_libraries(${BIN_NAME}
        ${Qt5Core_LIBRARIES}
        Qt5::PrintSupport
        )

## 安装目标文件
install(TARGETS ${BIN_NAME}
        DESTINATION /usr/bin/)

=== debian/changelog ===
uos-recovery (6.0.15-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Fri, 09 Dec 2022 16:56:46 +0800

uos-recovery (6.0.15) unstable; urgency=medium

  * new backup tool version 6.0.15

 -- Zhang Xueming <zhangxueming@uniontech.com>  Tue, 06 Dec 2022 18:50:39 +0800

uos-recovery (6.0.14) unstable; urgency=medium

  * new backup tool version 6.0.14

 -- Zhang Xueming <zhangxueming@uniontech.com>  Mon, 21 Nov 2022 10:27:30 +0800

uos-recovery (6.0.13) unstable; urgency=medium

  * new backup tool version 6.0.13

 -- Zhang Xueming <zhangxueming@uniontech.com>  Sun, 06 Nov 2022 23:22:15 +0800

uos-recovery (6.0.12) unstable; urgency=medium

  * new backup tool version 6.0.12

 -- Zhang Xueming <zhangxueming@uniontech.com>  Mon, 31 Oct 2022 18:06:47 +0800

uos-recovery (6.0.11) unstable; urgency=medium

  * new backup tool version 6.0.11

 -- Zhang Xueming <zhangxueming@uniontech.com>  Wed, 19 Oct 2022 13:49:31 +0800

uos-recovery (6.0.10) unstable; urgency=medium

  * new backup tool version 6.0.10

 -- Zhang Xueming <zhangxueming@uniontech.com>  Thu, 13 Oct 2022 15:11:50 +0800

uos-recovery (6.0.9) unstable; urgency=medium

  * new backup tool version 6.0.9

 -- Du Tianxue <dutianxue@uniontech.com>  Wed, 21 Sep 2022 20:50:44 +0800

uos-recovery (6.0.8) unstable; urgency=medium

  * new backup tool version 6.0.8

 -- Zhang Xueming <zhangxueming@uniontech.com>  Thu, 15 Aug 2022 20:49:13 +0800

uos-recovery (6.0.7) unstable; urgency=medium

  * new backup tool version 6.0.7

 -- Zhang Xueming <zhangxueming@uniontech.com>  Tue, 16 Aug 2022 15:07:05 +0800

uos-recovery (1.0.0) unstable; urgency=medium

  * new backup tool

 -- Guo Nafu <guonafu@uniontech.com>  Thu, 03 Mar 2022 10:37:13 +0800

=== debian/control ===
Source: uos-recovery
Section: misc
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.com>
Build-Depends:
    debhelper (>= 9),
    dh-systemd,
    pkg-config,
    cmake (>=3.1),
    g++ (>=6.3.0),
    qttools5-dev,
    qttools5-dev-tools,
    qtbase5-dev,
    libdtkcore-dev,
    libdtkgui-dev,
    libdtkwidget-dev,
    libdtkcore5-bin,
    libgtest-dev,
    libpolkit-qt5-1-dev
Standards-Version: 3.9.8
Homepage: https://www.deepin.org

Package: uos-recovery
Architecture: any
Depends:
    ${shlibs:Depends},
    ${misc:Depends},
    rsync,
    sqlite3,
    deepin-boot-kit
Description: uos recovery dbus service
 New version of uos-recovery, rewritten with Qt5.
Recommends: uos-reporter, deepin-event-log

Package: uimg-installer
Architecture: any
Depends:
    ${shlibs:Depends},
    ${misc:Depends},
    rsync
Description: installer uimg file
 written with Qt5.
Recommends: uos-reporter, deepin-event-log

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk
export QT_SELECT = qt5
DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_BUILD_TYPE=Release \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DAPP_VERSION=$(DEB_VERSION_UPSTREAM) \
	-DVERSION=$(DEB_VERSION_UPSTREAM) \
	LIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)

%:
	dh $@ --parallel

## uos-recovery 7.0.32

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,15 +1,15 @@
 # 工程设置
-cmake_minimum_required(VERSION 3.1)
+cmake_minimum_required(VERSION 3.19)
 project(uos-recovery C CXX)
 
-set(CMAKE_CXX_STANDARD_REQUIRED 14)
+set(CMAKE_CXX_STANDARD_REQUIRED 17)
 set(CMAKE_C_STANDARD 11)
 set(CMAKE_C_STANDARD_REQUIRED ON)
 
 # 启用qt moc机制
 set(CMAKE_AUTOMOC ON)
 set(CMAKE_AUTORCC ON)
-
+set(ENV{LC_ALL} "C.UTF-8")
 configure_file(${CMAKE_SOURCE_DIR}/src/utils/environments.h.in ${CMAKE_SOURCE_DIR}/src/utils/environments.h @ONLY)
 
 if (CMAKE_BUILD_TYPE MATCHES Debug)
@@ -38,21 +38,20 @@
 set(TEST_DIR ${CMAKE_SOURCE_DIR}/src/test)
 set(SERVER_DIR ${CMAKE_SOURCE_DIR}/src/uos-recovery-service)
 set(GUI_DIR ${CMAKE_SOURCE_DIR}/src/uos-recovery-gui)
-set(UIMGINSTALLERR_DIR ${CMAKE_SOURCE_DIR}/src/uimg-installer)
 set(RECOVERYTOOL_DIR ${CMAKE_SOURCE_DIR}/src/uos-recovery-tool)
 
-execute_process(COMMAND bash "-c" "qdbuscpp2xml -A ${SERVER_DIR}/RecoveryService.h -o com.deepin.daemon.uosrecovery.xml"
-        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
+set(QT6_PATH /usr/lib/qt6/)
+#execute_process(COMMAND bash "-c" "qdbuscpp2xml -A ${SERVER_DIR}/RecoveryService.h -o com.deepin.daemon.uosrecovery.xml"
+#        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
 
-execute_process(COMMAND bash "-c" "qdbusxml2cpp ${CMAKE_SOURCE_DIR}/com.deepin.daemon.uosrecovery.xml -i RecoveryService.h -a RecoveryAdaptor"
+execute_process(COMMAND bash "-c" "/usr/lib/qt6/bin/qdbusxml2cpp  ${CMAKE_SOURCE_DIR}/com.deepin.daemon.uosrecovery.xml -i RecoveryService.h -a RecoveryAdaptor"
         WORKING_DIRECTORY ${SERVER_DIR})
 
-execute_process(COMMAND bash "-c" "qdbusxml2cpp ${CMAKE_SOURCE_DIR}/com.deepin.daemon.uosrecovery.xml -p RecoveryProxy"
+execute_process(COMMAND bash "-c" "/usr/lib/qt6/bin/qdbusxml2cpp ${CMAKE_SOURCE_DIR}/com.deepin.daemon.uosrecovery.xml -i utils/global.h -p RecoveryProxy"
         WORKING_DIRECTORY ${GUI_DIR})
 
 add_subdirectory(src/uos-recovery-gui)
 add_subdirectory(src/uos-recovery-service)
-add_subdirectory(src/uimg-installer)
 add_subdirectory(src/uos-recovery-tool)
 
 if (CMAKE_BUILD_TYPE MATCHES Debug)

=== src/test/CMakeLists.txt ===
--- 
+++ 
@@ -3,18 +3,22 @@
 
 set(CMAKE_INCLUDE_CURRENT_DIR  ON)
 
-find_package(Qt5Core REQUIRED)
-find_package(Qt5Gui REQUIRED)
-find_package(Qt5PrintSupport REQUIRED)
-find_package(Qt5Widgets REQUIRED)
-find_package(Qt5DBus REQUIRED)
-find_package(DtkCMake REQUIRED)
+find_package(QT NAMES Qt6 REQUIRED COMPONENTS Core)
+find_package(Qt6 REQUIRED Widgets Gui Core DBus PrintSupport)
+
+#find_package(Qt5Core REQUIRED)
+#find_package(Qt5Gui REQUIRED)
+#find_package(Qt5PrintSupport REQUIRED)
+#find_package(Qt5Widgets REQUIRED)
+#find_package(Qt5DBus REQUIRED)
+find_package(Dtk6CMake REQUIRED)
 find_package(PkgConfig REQUIRED)
-find_package(PolkitQt5-1 REQUIRED)
-find_package(Qt5Sql REQUIRED)
+find_package(PolkitQt6-1 REQUIRED)
+find_package(Qt6Sql REQUIRED)
 
-pkg_check_modules(DtkWidget REQUIRED dtkwidget)
-
+pkg_check_modules(Dtk6Widget REQUIRED dtk6widget)
+pkg_search_module(UDisk2 REQUIRED udisks2-qt6)
+include_directories(AFTER ${UDisk2_INCLUDE_DIRS})
 include_directories(${CMAKE_SOURCE_DIR}/src)
 include_directories(${UTILS_DIR})
 
@@ -37,6 +41,8 @@
         ${SERVER_DIR}/BtrfsSystem.cpp
         ${SERVER_DIR}/LvmSystem.h
         ${SERVER_DIR}/LvmSystem.cpp
+        ${SERVER_DIR}/ImmutableSystem.h
+        ${SERVER_DIR}/ImmutableSystem.cpp
 
         ${SERVER_DIR}/UserDataRecovery.h
         ${SERVER_DIR}/UserDataRecovery.cpp
@@ -59,27 +65,38 @@
         ${SERVER_DIR}/UImgRecovery.cpp
         ${SERVER_DIR}/GhostUImg.h
         ${SERVER_DIR}/GhostUImg.cpp
+        ${SERVER_DIR}/BRContext.h
+        ${SERVER_DIR}/BRContext.cpp
+        ${SERVER_DIR}/URReadWriteLock.h
+        ${SERVER_DIR}/URReadWriteLock.cpp
+        ${SERVER_DIR}/OSTreeWorkerThread.h
+        ${SERVER_DIR}/OSTreeWorkerThread.cpp
+        ${SERVER_DIR}/WorkerThread.h
+        ${SERVER_DIR}/WorkerThread.cpp
 
-        ${UIMGINSTALLERR_DIR}/UImgOperate.h
-        ${UIMGINSTALLERR_DIR}/UImgOperate.cpp
+        ${RECOVERYTOOL_DIR}/RollbackNotify.h
+        ${RECOVERYTOOL_DIR}/RollbackNotify.cpp
         )
 
 target_include_directories(${BIN_NAME} PUBLIC
         ${DtkWidget_INCLUDE_DIRS}
+        ${DTKCORE_INCLUDE_DIRS}
+        ${UDisk2_INCLUDE_DIRS}
         )
 
 target_link_libraries(${BIN_NAME}
-        ${Qt5Widgets_LIBRARIES}
-        ${Qt5DBus_LIBRARIES}
-        ${DtkWidget_LIBRARIES}
-        Qt5::PrintSupport
-        PolkitQt5-1::Agent
-        ${Qt5Sql_LIBRARIES}
+        ${Qt6Widgets_LIBRARIES}
+        ${Qt6DBus_LIBRARIES}
+        ${Dtk6Widget_LIBRARIES}
+        Qt6::PrintSupport
+        PolkitQt6-1::Agent
+        ${Qt6Sql_LIBRARIES}
+        ${UDisk2_LIBRARIES}
         )
 
 target_link_libraries(${BIN_NAME}
-        Qt5::Core
-        Qt5::DBus
+        Qt6::Core
+        Qt6::DBus
         gtest
         gtest_main
         pthread

=== src/uos-recovery-gui/CMakeLists.txt ===
--- 
+++ 
@@ -1,16 +1,21 @@
 set(BIN_NAME uos-recovery-gui)
 
-find_package(Qt5Core REQUIRED)
-find_package(Qt5Gui REQUIRED)
-find_package(Qt5PrintSupport REQUIRED)
-find_package(Qt5Widgets REQUIRED)
-find_package(Qt5DBus REQUIRED)
-find_package(DtkCMake REQUIRED)
+#find_package(QT NAMES Qt6 REQUIRED COMPONENTS Core)
+find_package(Qt6  COMPONENTS Widgets Core DBus Sql LinguistTools REQUIRED)
+#find_package(Qt5Core REQUIRED)
+#find_package(Qt5Gui REQUIRED)
+find_package(Qt6PrintSupport REQUIRED)
+#find_package(Qt5Widgets REQUIRED)
+#find_package(Qt5DBus REQUIRED)
+find_package(Dtk6CMake REQUIRED)
 find_package(PkgConfig REQUIRED)
-find_package(PolkitQt5-1 REQUIRED)
+find_package(PolkitQt6-1 REQUIRED)
 
-pkg_check_modules(DtkWidget REQUIRED dtkwidget)
+pkg_check_modules(Dtk6Widget REQUIRED dtk6widget)
 
+pkg_search_module(UDisk2 REQUIRED udisks2-qt6)
+pkg_search_module(SELINUX REQUIRED libselinux)
+include_directories(AFTER ${UDisk2_INCLUDE_DIRS})
 include_directories(${CMAKE_SOURCE_DIR}/src)
 include_directories(.)
 
@@ -19,7 +24,11 @@
 aux_source_directory(${GUI_DIR}/restore/ GUI_SRCS)
 aux_source_directory(${GUI_DIR}/advanced/ GUI_SRCS)
 aux_source_directory(${GUI_DIR}/common/ GUI_SRCS)
+aux_source_directory(${GUI_DIR}/immutable/backup/ GUI_SRCS)
+aux_source_directory(${GUI_DIR}/immutable/factoryrestore/ GUI_SRCS)
+aux_source_directory(${GUI_DIR}/immutable/restore/ GUI_SRCS)
 aux_source_directory(${UTILS_DIR} GUI_SRCS)
+aux_source_directory(${GUI_DIR}/dbus/session GUI_SRCS)
 
 add_executable(${BIN_NAME}
         ${GUI_SRCS}
@@ -27,33 +36,38 @@
         )
 
 target_include_directories(${BIN_NAME} PUBLIC
-        ${DtkWidget_INCLUDE_DIRS}
+        ${Dtk6Widget_INCLUDE_DIRS}
+        ${DTK6CORE_INCLUDE_DIRS}
+        ${UDisk2_INCLUDE_DIRS}
+        ${SELINUX_INCLUDE_DIRS}
         )
 
 
 target_link_libraries(${BIN_NAME}
-        ${Qt5Widgets_LIBRARIES}
-        ${Qt5DBus_LIBRARIES}
-        ${DtkWidget_LIBRARIES}
-        Qt5::PrintSupport
-        PolkitQt5-1::Agent
+        ${Qt6Widgets_LIBRARIES}
+        ${Qt6DBus_LIBRARIES}
+        ${Dtk6Widget_LIBRARIES}
+        ${UDisk2_LIBRARIES}
+        ${SELINUX_LIBRARIES}
+        Qt6::PrintSupport
+        PolkitQt6-1::Agent
         )
 
 # 生成翻译
 ## 设置QT语言cmake模块
-find_package(Qt5 COMPONENTS Widgets LinguistTools REQUIRED)
+#find_package(Qt5 COMPONENTS Widgets LinguistTools REQUIRED)
 
 ## 通过源代码生成ts文件
 set(CREATE_TS_DIR
-    ${CMAKE_SOURCE_DIR}/src/uos-recovery-gui
-)
+        ${CMAKE_SOURCE_DIR}/src/uos-recovery-gui
+        )
 
 find_program(LUPDATE_EXECUTABLE lupdate)
 execute_process(
-    COMMAND ${LUPDATE_EXECUTABLE} -source-language en
-    -no-obsolete
-    -recursive ${CREATE_TS_DIR}
-    -ts ${CMAKE_SOURCE_DIR}/translations/gui/uos-recovery-gui.ts)
+        COMMAND ${LUPDATE_EXECUTABLE} -source-language en
+        -no-obsolete
+        -recursive ${CREATE_TS_DIR}
+        -ts ${CMAKE_SOURCE_DIR}/translations/gui/uos-recovery-gui.ts)
 
 execute_process(
         COMMAND python ${CMAKE_CURRENT_SOURCE_DIR}/translate_gui_unfinised.py ${CMAKE_SOURCE_DIR}/translations/gui/uos-recovery-gui.ts
@@ -64,7 +78,7 @@
 
 ## 获取ts源文件
 file(GLOB INSTALLER_TRANSLATION_TS
-    ${CMAKE_SOURCE_DIR}/translations/gui/uos-recovery-gui*.ts)
+        ${CMAKE_SOURCE_DIR}/translations/gui/uos-recovery-gui*.ts)
 
 # generate qm
 execute_process(COMMAND bash "${CMAKE_SOURCE_DIR}/translate_generation.sh"
@@ -97,5 +111,14 @@
 
 #desktop
 # desktop
-install(FILES uos-recovery.desktop DESTINATION /usr/share/applications)
+install(FILES uos-recovery-gui.desktop DESTINATION /usr/share/applications)
 
+install(FILES com.deepin.uosrecovery.metainfo.xml DESTINATION /usr/share/metainfo)
+
+# help manual
+install(DIRECTORY ${CMAKE_SOURCE_DIR}/assets/uos-recovery-gui
+        DESTINATION /usr/share/deepin-manual/manual-assets/application/)
+
+#dbus service
+install(FILES dbus/session/com.deepin.uosrecovery.session.service
+        DESTINATION /usr/share/dbus-1/services/)

=== src/uos-recovery-service/CMakeLists.txt ===
--- 
+++ 
@@ -5,15 +5,19 @@
 aux_source_directory(${UTILS_DIR}/data-collection SERVICE_SRCS)
 aux_source_directory(${SERVER_DIR} SERVICE_SRCS)
 
+find_package(QT NAMES Qt6 REQUIRED COMPONENTS Core)
+find_package(Qt6 REQUIRED Widgets Core DBus Sql)
 find_package(PkgConfig REQUIRED)
-find_package(Qt5Core REQUIRED)
-find_package(DtkCMake REQUIRED)
-find_package(DtkWidget REQUIRED)
-find_package(Qt5Widgets REQUIRED)
-find_package(Qt5DBus REQUIRED)
-find_package(Qt5Sql REQUIRED)
-find_package(PolkitQt5-1 REQUIRED)
+#find_package(Qt5Core REQUIRED)
+find_package(Dtk6CMake REQUIRED)
+find_package(Dtk6Widget REQUIRED)
+#find_package(Qt5Widgets REQUIRED)
+#find_package(Qt6DBus REQUIRED)
+#find_package(Qt6Sql REQUIRED)
+find_package(PolkitQt6-1 REQUIRED)
 
+pkg_search_module(UDisk2 REQUIRED udisks2-qt6)
+include_directories(AFTER ${UDisk2_INCLUDE_DIRS})
 include_directories(${CMAKE_SOURCE_DIR}/src)
 
 aux_source_directory(${SERVER_DIR} SERVICE_SRCS)
@@ -23,16 +27,19 @@
         )
 
 target_include_directories(${BIN_NAME} PUBLIC
-        ${DtkWidget_INCLUDE_DIRS}
+        ${Dtk6Widget_INCLUDE_DIRS}
+        ${DTK6CORE_INCLUDE_DIRS}
+        ${UDisk2_INCLUDE_DIRS}
         )
 
 
 target_link_libraries(${BIN_NAME}
-        ${Qt5Widgets_LIBRARIES}
-        ${Qt5DBus_LIBRARIES}
-        ${Qt5Sql_LIBRARIES}
-        ${DtkWidget_LIBRARIES}
-        PolkitQt5-1::Agent
+        ${Qt6Widgets_LIBRARIES}
+        ${Qt6DBus_LIBRARIES}
+        ${Qt6Sql_LIBRARIES}
+        ${Dtk6Widget_LIBRARIES}
+        ${UDisk2_LIBRARIES}
+        PolkitQt6-1::Agent
         )
 
 
@@ -76,6 +83,12 @@
 install(FILES service/com.deepin.uosrecovery.service
         DESTINATION /usr/share/dbus-1/system-services/)
 
+install(FILES service/uos-recovery.service
+        DESTINATION /usr/lib/systemd/system/)
 # dbus policy
 install(FILES service/com.deepin.uosrecovery.policy
         DESTINATION /usr/share/polkit-1/actions/)
+
+# rollback notify
+install(FILES service/uos-recovery-notify.desktop
+        DESTINATION /usr/share/uos-recovery/)

=== src/uos-recovery-tool/CMakeLists.txt ===
set(BIN_NAME uos-recovery-tool)

find_package(QT NAMES Qt6 REQUIRED COMPONENTS Core)
find_package(Qt6 REQUIRED Widgets Core DBus PrintSupport)

#find_package(Qt5Core REQUIRED)
#find_package(Qt5PrintSupport REQUIRED)
find_package(Dtk6CMake REQUIRED)
#find_package(Qt5DBus REQUIRED)

include_directories(${CMAKE_SOURCE_DIR}/src)
aux_source_directory(${RECOVERYTOOL_DIR} SRC_FILES)

# 生成翻译
## 设置QT语言cmake模块
find_package(Qt6 COMPONENTS LinguistTools REQUIRED)

## 通过源代码生成ts文件
set(CREATE_TS_DIR
        ${CMAKE_SOURCE_DIR}/src/uos-recovery-tool
        )

find_program(LUPDATE_EXECUTABLE lupdate)
execute_process(
        COMMAND ${LUPDATE_EXECUTABLE} -source-language en
        -no-obsolete
        -recursive ${CREATE_TS_DIR}
        -ts ${CMAKE_SOURCE_DIR}/translations/tool/uos-recovery-tool.ts)

execute_process(
        COMMAND python ${CMAKE_CURRENT_SOURCE_DIR}/translate_tool_unfinised.py ${CMAKE_SOURCE_DIR}/translations/tool/uos-recovery-tool.ts
        ${CMAKE_SOURCE_DIR}/translations/tool/uos-recovery-tool_en_US.ts)
#execute_process(
#        COMMAND cp -rf ${CMAKE_SOURCE_DIR}/translations/tool/uos-recovery-tool.ts
#        ${CMAKE_SOURCE_DIR}/translations/tool/uos-recovery-tool_en_US.ts)

## 获取ts源文件
file(GLOB INSTALLER_TRANSLATION_TS
        ${CMAKE_SOURCE_DIR}/translations/tool/uos-recovery-tool*.ts)

# generate qm
execute_process(COMMAND bash "${CMAKE_SOURCE_DIR}/translate_generation.sh"
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

if (CMAKE_BUILD_TYPE MATCHES Debug)
    add_definitions("-DDI_I18N_TOOL_DIR_ENV=\"${CMAKE_SOURCE_DIR}/translations/tool\"")
else()
    add_definitions("-DDI_I18N_TOOL_DIR_ENV=\"/usr/share/uos-recovery/translations/tool\"")
endif()

# tool
file(GLOB QM_FILES "${CMAKE_SOURCE_DIR}/translations/tool/*.qm")
install(FILES ${QM_FILES}
        DESTINATION /usr/share/uos-recovery/translations/tool/)

## 源文件
add_executable(${BIN_NAME}
        ${SRC_FILES}
        main.cpp)

target_link_libraries(${BIN_NAME}
        ${Qt6Core_LIBRARIES}
        ${Qt6DBus_LIBRARIES}
        Qt6::PrintSupport
        )

## 安装目标文件
install(TARGETS ${BIN_NAME}
        DESTINATION /usr/bin/)

=== debian/changelog ===
uos-recovery (7.0.32) unstable; urgency=medium

  * new backup tool version 7.0.32 V25
  *

wangzhaohui <wangzhaohui@uniontech.com>  Tue, 25 Nov 2025 20:31:18 +0800

uos-recovery (7.0.26) unstable; urgency=medium

  * new backup tool version 7.0.26 V25
  *

Zhang Xueming <zhangxueming@uniontech.com>  Mon, 23 Jun 2025 16:39:45 +0800

uos-recovery (7.0.25) unstable; urgency=medium

  * new backup tool version 7.0.25 V25
  *

Zhang Xueming <zhangxueming@uniontech.com>  Mon, 23 Jun 2025 14:14:00 +0800

uos-recovery (7.0.24) unstable; urgency=medium

  * new backup tool version 7.0.24 V25
  *

Zhang Xueming <zhangxueming@uniontech.com>  Mon, 16 Jun 2025 10:15:00 +0800

uos-recovery (7.0.23) unstable; urgency=medium

  * new backup tool version 7.0.23 V25
  *

Zhang Xueming <zhangxueming@uniontech.com>  Fri, 06 Jun 2025 11:17:27 +0800

uos-recovery (7.0.22) unstable; urgency=medium

  * new backup tool version 7.0.22 V25
  *

Zhang Xueming <zhangxueming@uniontech.com>  Tue, 03 Jun 2025 16:13:32 +0800

uos-recovery (7.0.21.1) unstable; urgency=medium

  * new backup tool version 7.0.21.1 V25
  * System Clone

Zhang Xueming <zhangxueming@uniontech.com>  Tue, 20 May 2025 15:59:47 +0800

uos-recovery (7.0.21) unstable; urgency=medium

  * new backup tool version 7.0.21 V25
  * new ui

Zhang Xueming <zhangxueming@uniontech.com>  Mon, 19 May 2025 17:05:16 +0800

uos-recovery (7.0.20) unstable; urgency=medium

  * new backup tool version 7.0.20 V25
  *

Zhang Xueming <zhangxueming@uniontech.com>  Fri, 09 May 2025 10:37:33 +0800

uos-recovery (7.0.19) unstable; urgency=medium

  * new backup tool version 7.0.19 V25
  *

Zhang Xueming <zhangxueming@uniontech.com>  Mon, 21 Apr 2025 16:46:20 +0800

uos-recovery (7.0.18) unstable; urgency=medium

  * new backup tool version 7.0.18 V25
  *

Zhang Xueming <zhangxueming@uniontech.com>  Wed, 16 Apr 2025 16:40:05 +0800

uos-recovery (7.0.17) unstable; urgency=medium

  * new backup tool version 7.0.17 V25
  *

Zhang Xueming <zhangxueming@uniontech.com>  Thu, 10 Apr 2025 14:43:21 +0800

uos-recovery (7.0.16) unstable; urgency=medium

  * new backup tool version 7.0.16 V25
  *

Zhang Xueming <zhangxueming@uniontech.com>  Fri, 28 Mar 2025 15:16:37 +0800

uos-recovery (7.0.15) unstable; urgency=medium

  * new backup tool version 7.0.15 V25
  *

Zhang Xueming <zhangxueming@uniontech.com>  Fri, 14 Mar 2025 13:37:06 +0800

uos-recovery (7.0.14) unstable; urgency=medium

  * new backup tool version 7.0.14 V25
  *

Zhang Xueming <zhangxueming@uniontech.com>  Fri, 07 Mar 2025 10:34:36 +0800

uos-recovery (7.0.13) unstable; urgency=medium

  * new backup tool version 7.0.13 V25
  *

Zhang Xueming <zhangxueming@uniontech.com>  Thu, 20 Feb 2025 14:39:32 +0800

uos-recovery (7.0.12) unstable; urgency=medium

  * new backup tool version 7.0.12 V25
  *

Zhang Xueming <zhangxueming@uniontech.com>  Thu, 13 Feb 2025 14:57:32 +0800

uos-recovery (7.0.11) unstable; urgency=medium

  * new backup tool version 7.0.11 V25
  *

Zhang Xueming <zhangxueming@uniontech.com>  Fri, 17 Jan 2025 15:18:55 +0800

uos-recovery (7.0.9) unstable; urgency=medium

  * new backup tool version 7.0.9 V25
  *

Zhang Xueming <zhangxueming@uniontech.com>   Fri, 03 Jan 2025 16:18:50 +0800

uos-recovery (7.0.8) unstable; urgency=medium

  * new backup tool version 7.0.8 V25
  *

Zhang Xueming <zhangxueming@uniontech.com>   Thu, 05 Dec 2024 21:06:31 +0800

uos-recovery (7.0.7) unstable; urgency=medium

  * new backup tool version 7.0.7 V25
  *

Zhang Xueming <zhangxueming@uniontech.com>   Thu, 05 Dec 2024 21:06:31 +0800

uos-recovery (7.0.6) unstable; urgency=medium

  * new backup tool version 7.0.6 V25
  *

Zhang Xueming <zhangxueming@uniontech.com>  Thu, 21 Nov 2024 09:36:36 +0800

uos-recovery (7.0.5) unstable; urgency=medium

  * new backup tool version 7.0.5 V25
  *

Zhang Xueming <zhangxueming@uniontech.com>  Thu, 21 Nov 2024 09:36:36 +0800

uos-recovery (7.0.3) unstable; urgency=medium

  * new backup tool version 7.0.3 V25
  * 

Zhang Xueming <zhangxueming@uniontech.com>  Wed, 30 Oct 2024 16:42:36 +0800

uos-recovery (7.0.1) unstable; urgency=medium

  * new backup tool version 7.0.1 V25

Zhang Xueming <zhangxueming@uniontech.com> Fri, 27 Sep 2024 11:23:28 +0800

uos-recovery (7.0.0) unstable; urgency=medium

  * new backup tool version 7.0.0 V25

Zhang Xueming <zhangxueming@uniontech.com> Fri, 27 Sep 2024 11:23:28 +0800

=== debian/control ===
Source: uos-recovery
Section: misc
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.com>
Build-Depends:
    debhelper (>= 9),
    pkg-config,
    cmake (>=3.1),
    g++ (>=6.3.0),
    qt6-base-dev,
    qt6-tools-dev,
    qt6-tools-dev-tools,
    qt6-base-dev-tools,
    libdtk6core-dev,
    libdtk6gui-dev,
    libdtk6widget-dev,
    libdtk6core-bin,
    libgtest-dev,
    libpolkit-qt6-1-dev,
    libudisks2-qt6-dev,
    libqt6sql6-sqlite,
    libselinux1-dev
Standards-Version: 3.9.8
Homepage: https://www.deepin.org

Package: uos-recovery
Architecture: any
Depends:
    ${shlibs:Depends},
    ${misc:Depends},
    rsync,
    sqlite3,
    libqt6sql6-sqlite,
    squashfs-tools
Recommends:
    uos-reporter,
    deepin-event-log
Description: uos recovery dbus service
 New version of uos-recovery, rewritten with Qt5.

=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #!/usr/bin/make -f
 
 include /usr/share/dpkg/default.mk
-export QT_SELECT = qt5
+export QT_SELECT = qt6
 DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
 override_dh_auto_configure:
 	dh_auto_configure -- \
@@ -14,3 +14,5 @@
 %:
 	dh $@ --parallel
 
+override_dh_installsystemd:
+	dh_installsystemd --no-start --no-enable uos-recovery.service
